function [t,df] = tvalue(data1,data2,dim,vartype)

if nargin < 3
    dim = 1;
end

if nargin < 4
    vartype = 'e';
end


if isempty(data2)
    cnt = sum(~isnan(data1),dim);
    t   = nanmean(data1,dim) ./ nanstd(data1,0,dim) .* cnt;
    df = cnt -1;
else
    cnt1 = sum(~isnan(data1),dim);
    cnt2 = sum(~isnan(data2),dim);
    df = cnt1+cnt2-2;
    switch vartype
        case 'e'

            v = (nanvar(data1,0,dim) .* (cnt1-1) +  nanvar(data2,0,dim) .* (cnt2-1)) ./ (cnt1 +  cnt2 -2);  % Correct
%            v = (var(data1,0,dim) * (size(data1,dim)-1) +  var(data2,0,dim) * (size(data2,dim)-1)) / (size(data1,dim) +  size(data2,dim));  % Roberto
            t = (nanmean(data1,dim) -nanmean(data2,dim))./ sqrt(v .* (1./cnt1 + 1./cnt2));
        case 'u'
            t = (nanmean(data1,dim) -nanmean(data2,dim))./ sqrt(nanvar(data1,0,dim)./cnt1 + nanvar(data2,0,dim)./cnt2);
        otherwise
            error('tvalue: Variance type falsly defined');
    end
end